

import { StackBuilder } from './';
const { ApolloServer, gql } = require('apollo-server-express')
const express =  require('express')
const cors = require('cors')

export const Server = async ( port , configs, router = null , playground = true ) => {

    try {
        const { context, schema } = await StackBuilder(configs, { auth: false });
        const server = new ApolloServer({
            context,
            schema,
            playground: playground
        });

        const app = express();
        server.applyMiddleware({ app });
        app.use(
            cors({
                methods: ["GET", "POST", "PUT", "PATCH", "DELETE"],
                exposedHeaders: ["Content-Disposition"],
                credentials: true
            })
        );

        app.use('/rest/', router )

        app.listen({ port: port }, () =>
            console.log(`🚀 Server ready at Port:${port}${server.graphqlPath}`)
        );

    } catch (error) {
        console.log(error);
    }
}